gtkmm: Gtk::ToolPalette Class Reference

gtkmm 2.24.5

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::ToolPalette Class Reference
Widgets | Container Widgets

A ToolPalette allows you to add ToolItems to a palette-like container with various categories and drag and drop support. More...

Inheritance diagram for Gtk::ToolPalette:
[legend]
Collaboration diagram for Gtk::ToolPalette:
[legend]

## Public Member Functions
virtual | ~ToolPalette ()
GtkToolPalette* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkToolPalette* | gobj () const
| Provides access to the underlying C GtkObject. More...
| ToolPalette ()
void | set_group_position (ToolItemGroup& group, int position)
| Sets the position of the group as an index of the tool palette. More...
void | set_exclusive (ToolItemGroup& group, bool exclusive)
| Sets whether the group should be exclusive or not. More...
void | set_expand (ToolItemGroup& group, bool expand=true)
| Sets whether the group should be given extra space. More...
int | get_group_position (ToolItemGroup& group) const
| Gets the position of group in palette as index. More...
bool | get_exclusive (ToolItemGroup& group) const
| Gets whether group is exclusive or not. More...
bool | get_expand (ToolItemGroup& group) const
| Gets whether group should be given extra space. More...
void | set_icon_size (IconSize icon_size)
| Sets the size of icons in the tool palette. More...
void | unset_icon_size ()
| Unsets the tool palette icon size set with set_icon_size(), so that user preferences will be used to determine the icon size. More...
void | set_style (ToolbarStyle style)
| Sets the style (text, icons or both) of items in the tool palette. More...
void | unset_style ()
| Unsets a toolbar style set with set_style(), so that user preferences will be used to determine the toolbar style. More...
IconSize | get_icon_size () const
| Gets the size of icons in the tool palette. More...
ToolbarStyle | get_style () const
| Gets the style (icons, text or both) of items in the tool palette. More...
ToolItem* | get_drop_item (int x, int y)
| Gets the item at position (x, y). More...
const ToolItem* | get_drop_item (int x, int y) const
| Gets the item at position (x, y). More...
ToolItemGroup* | get_drop_group (int x, int y)
| Gets the group at position (x, y). More...
const ToolItemGroup* | get_drop_group (int x, int y) const
| Gets the group at position (x, y). More...
ToolItem* | get_drag_item (const SelectionData& selection)
| Get the dragged item from the selection. More...
const ToolItem* | get_drag_item (const SelectionData& selection) const
| Get the dragged item from the selection. More...
void | set_drag_source (ToolPaletteDragTargets targets=TOOL_PALETTE_DRAG_ITEMS)
| Sets the tool palette as a drag source. More...
void | add_drag_dest (Gtk::Widget& widget, DestDefaults flags=DEST_DEFAULT_ALL, ToolPaletteDragTargets targets=TOOL_PALETTE_DRAG_ITEMS, Gdk::DragAction actions=Gdk::ACTION_COPY)
| Sets palette as drag source (see set_drag_source()) and sets widget as a drag destination for drags from palette. More...
Adjustment* | get_hadjustment ()
| Gets the horizontal adjustment of the tool palette. More...
const Adjustment* | get_hadjustment () const
| Gets the horizontal adjustment of the tool palette. More...
Adjustment* | get_vadjustment ()
| Gets the vertical adjustment of the tool palette. More...
const Adjustment* | get_vadjustment () const
| Gets the vertical adjustment of the tool palette. More...
Glib::PropertyProxy< IconSize > | property_icon_size ()
| Size of icons in this tool palette. More...
Glib::PropertyProxy_ReadOnly< IconSize > | property_icon_size () const
| Size of icons in this tool palette. More...
Glib::PropertyProxy< bool > | property_icon_size_set ()
| Whether the icon-size property has been set. More...
Glib::PropertyProxy_ReadOnly< bool > | property_icon_size_set () const
| Whether the icon-size property has been set. More...
Glib::PropertyProxy< ToolbarStyle > | property_toolbar_style ()
| Style of items in the tool palette. More...
Glib::PropertyProxy_ReadOnly< ToolbarStyle > | property_toolbar_style () const
| Style of items in the tool palette. More...
Public Member Functions inherited from Gtk::Container
virtual | ~Container ()
GtkContainer* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkContainer* | gobj () const
| Provides access to the underlying C GtkObject. More...
void | set_border_width (guint border_width)
| Sets the border width of the container. More...
guint | get_border_width () const
| Retrieves the border width of the container. More...
virtual void | add (Widget& widget)
void | remove (Widget& widget)
| Removes widget from container. More...
void | set_resize_mode (ResizeMode resize_mode)
| Sets the resize mode for the container. More...
ResizeMode | get_resize_mode () const
| Returns the resize mode for the container. More...
void | check_resize ()
| Request that contained widgets check their size. More...
void | foreach (const ForeachSlot& slot)
| Operate on contained items This is largely an internal used mainly for things like creating duplicates of internal lists and other such operations. More...
Glib::ListHandle< Widget* > | get_children ()
| (internal) Operate on contained items (see foreach()) More...
Glib::ListHandle< const Widget* > | get_children () const
| Returns the container's non-internal children. More...
void | propagate_expose (Widget& child, GdkEventExpose*event)
| When a container receives an expose event, it must send synthetic expose events to all children that don't have their own Gdk::Windows. More...
void | set_focus_chain (const Glib::ListHandle< Widget*>& focusable_widgets)
| Sets a focus chain, overriding the one computed automatically by GTK+. More...
bool | has_focus_chain () const
Glib::ListHandle< Widget* > | get_focus_chain ()
Glib::ListHandle< const Widget* > | get_focus_chain () const
void | unset_focus_chain ()
| Removes a focus chain explicitly set with set_focus_chain(). More...
void | set_reallocate_redraws (bool needs_redraws=true)
| Sets the reallocate_redraws flag of the container to the given value. More...
void | set_focus_child (Widget& widget)
| Sets the focus on a child. More...
void | set_focus_vadjustment (Adjustment& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Adjustment* | get_focus_vadjustment ()
| Retrieves the vertical focus adjustment for the container. More...
const Adjustment* | get_focus_vadjustment () const
| Retrieves the vertical focus adjustment for the container. More...
void | set_focus_hadjustment (Adjustment& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Adjustment* | get_focus_hadjustment ()
| Retrieves the horizontal focus adjustment for the container. More...
const Adjustment* | get_focus_hadjustment () const
| Retrieves the horizontal focus adjustment for the container. More...
void | resize_children ()
GType | child_type () const
| Returns the type of the children supported by the container. More...
Glib::SignalProxy< void, Widget*> | signal_add ()
Glib::SignalProxy< void, Widget*> | signal_remove ()
Glib::SignalProxy< void > | signal_check_resize ()
Glib::SignalProxy< void, Widget*> | signal_set_focus_child ()
void | show_all_children (bool recursive=true)
Public Member Functions inherited from Gtk::Widget
virtual | ~Widget ()
GtkWidget* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkWidget* | gobj () const
| Provides access to the underlying C GtkObject. More...
bool | set_scroll_adjustments (Adjustment& hadjustment, Adjustment& vadjustment)
| For widgets that support scrolling, sets the scroll adjustments and returns `true`. More...
void | show ()
| Flags a widget to be displayed. More...
void | show_now ()
| Shows a widget. More...
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user). More...
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container). More...
void | hide_all ()
| Recursively hides a widget and any child widgets. More...
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget. More...
void | queue_draw_area (int x, int y, int width, int height)
| Invalidates the rectangular area of widget defined by x, y, width and height by calling gdk_window_invalidate_rect() on the widget's window and all its child windows. More...
void | queue_resize ()
| This function is only for use in widget implementations. More...
Requisition | size_request () const
| This function is typically used when implementing a Gtk::Container subclass. More...
void | size_request (const Requisition& requisition)
| This function is typically used when implementing a Gtk::Container subclass. More...
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets. More...
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated. More...
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator(). More...
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal. More...
bool | event (GdkEvent* event)
| Rarely-used function. More...
int | send_expose (GdkEvent*event)
| Very rarely-used function. More...
bool | send_focus_change (GdkEvent*event)
| Sends the focus change event to widget. More...
bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.) this function activates them. More...
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget. More...
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection. More...
Gdk::Region | region_intersect (const Gdk::Region& region) const
| Computes the intersection of a widget's area and region, returning the intersection. More...
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget. More...
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget. More...
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify(). More...
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus. More...
bool | get_can_focus () const
| Determines whether widget can own the input focus. More...
bool | can_focus () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside. More...
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget. More...
bool | get_can_default () const
| Determines whether widget can be a default widget. More...
bool | can_default () const
| Determines whether widget can be a default widget. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | grab_default ()
| Causes widget to become the default widget. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default. More...
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse). More...
void | add_modal_grab ()
| Block events to everything else than this widget and its children. More...
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed. More...
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a gtkrc file. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state (StateType state)
| This function is for use in widget implementations. More...
StateType | get_state () const
| Returns the widget's state. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()). More...
bool | is_sensitive () const
| Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensntive. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own. More...
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own. More...
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget. More...
bool | get_is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_expose_event() handler. More...
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_expose_event() handler. More...
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering. More...
bool | get_double_buffered () const
| Determines whether the widget is double buffered. More...
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes. More...
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show(). More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window. More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget's window if it is realized, `nullptr` otherwise. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget's window if it is realized, `nullptr` otherwise. More...
Allocation | get_allocation () const
| Retrieves the widget's location. More...
void | set_allocation (const Allocation& allocation)
| Sets the widget's allocation. More...
Container* | get_parent ()
| Returns the parent container of widget. More...
const Container* | get_parent () const
| Returns the parent container of widget. More...
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget's parent window. More...
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget's parent window. More...
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget. More...
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order. More...
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be width by height. More...
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget. More...
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget. More...
void | set_extension_events (Gdk::ExtensionMode mode)
| Sets the extension events mask to mode. More...
Gdk::ExtensionMode | get_extension_events () const
| Retrieves the extension events the widget will receive; see gdk_input_set_extension_events(). More...
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
Glib::RefPtr< Gdk::Colormap > | get_colormap ()
| Gets the colormap that will be used to render widget. More...
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located. More...
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings (global property settings, RC file information, etc) used for this widget. More...
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< Gdk::Pixmap > | get_snapshot (Gdk::Rectangle& clip_rect) const
| Create a Gdk::Pixmap of the contents of the widget and its children. More...
Glib::RefPtr< Gdk::Pixmap > | get_snapshot () const
| Create a Gdk::Pixmap of the contents of the widget and its children. More...
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology. More...
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology. More...
void | set_colormap (const Glib::RefPtr< const Gdk::Colormap >& colormap)
| Sets the colormap for the widget to the given value. More...
Gdk::EventMask | get_events () const
| Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration). More...
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates. More...
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations. More...
bool | has_rc_style () const
| Determines if the widget style has been looked up through the rc mechanism. More...
void | set_style (const Glib::RefPtr< Style >& style)
| Sets the Gtk::Style for a widget ( widget->style). More...
void | unset_style ()
void | ensure_style ()
| Ensures that widget has a style ( widget->style). More...
Glib::RefPtr< Style > | get_style ()
| Simply an accessor function that returns widget->style. More...
Glib::RefPtr< const Style > | get_style () const
| Simply an accessor function that returns widget->style. More...
void | modify_style (const Glib::RefPtr< RcStyle >& style)
| Modifies style values on the widget. More...
Glib::RefPtr< RcStyle > | get_modifier_style ()
| Returns the current modifier style for the widget. More...
Glib::RefPtr< const RcStyle > | get_modifier_style () const
| Returns the current modifier style for the widget. More...
void | modify_fg (StateType state, const Gdk::Color& color)
| Sets the foreground color for a widget in a particular state. More...
void | modify_bg (StateType state, const Gdk::Color& color)
| Sets the background color for a widget in a particular state. More...
void | modify_bg_pixmap (StateType state, const Glib::ustring& pixmap_name)
void | modify_text (StateType state, const Gdk::Color& color)
| Sets the text color for a widget in a particular state. More...
void | modify_base (StateType state, const Gdk::Color& color)
| Sets the base color for a widget in a particular state. More...
void | modify_cursor (const Gdk::Color& primary, const Gdk::Color& secondary)
| Sets the cursor color to use in a widget, overriding the cursor_color and secondary_cursor_color style properties. More...
void | unset_cursor ()
| See modify_cursor(). More...
void | modify_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget. More...
void | unset_fg (StateType state)
| Undo the effect of previous calls to modify_fg() for a particular state. More...
void | unset_bg (StateType state)
| Undo the effect of previous calls to modify_bg() for a particular state. More...
void | unset_text (StateType state)
| Undo the effect of previous calls to modify_text() for a particular state. More...
void | unset_base (StateType state)
| Undo the effect of previous calls to modify_base() for a particular state. More...
void | unset_font ()
| Undo the effect of previous calls to modify_font() for a particular state. More...
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType& value) const
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Gdk::Pixbuf > | render_icon (const StockID& stock_id, IconSize size, const Glib::ustring& detail=Glib::ustring())
| A convenience function that uses the theme engine and RC file settings for the widget to look up stock_id and render it to a pixbuf. More...
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name. More...
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget. More...
void | reset_rc_styles ()
| Reset the styles of widget and all descendents, so when they are looked up again, they get the correct values for the currently loaded RC file settings. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction ()
| Gets the reading direction for a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | shape_combine_mask (const Glib::RefPtr< const Gdk::Bitmap >& shape_mask, int offset_x, int offset_y)
| Sets a shape for this widget's GDK window. More...
void | unset_shape_combine_mask ()
void | input_shape_combine_mask (const Glib::RefPtr< const Gdk::Bitmap >& shape_mask, int offset_x, int offset_y)
| Sets an input shape for this widget's GDK window. More...
void | unset_input_shape_combine_mask ()
void | reset_shapes ()
| Recursively resets the shape on this widget and its descendants. More...
void | path (Glib::ustring& path, Glib::ustring& path_reversed)
| Compute a widget's path of the form "GtkWindow.MyLabel". More...
void | class_path (Glib::ustring&path, Glib::ustring& path_reversed)
Glib::ListHandle< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is a the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
Glib::ListHandle< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is a the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget. More...
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, Glib::ustring& target, guint32 time)
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
void | drag_highlight ()
void | drag_unhighlight ()
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const ArrayHandle_TargetEntry& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
void | drag_dest_unset ()
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE. More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop. More...
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop. More...
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop. More...
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_source_set (const ArrayHandle_TargetEntry& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Colormap >& colormap, const Glib::RefPtr< Gdk::Pixmap >& pixmap, const Glib::RefPtr< Gdk::Bitmap >& mask)
| Sets the icon that will be used for drags from a particular widget from a pixmap/mask. More...
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf. More...
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon. More...
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon. More...
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::Selection to the target list of the drag source. More...
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent*event)
| Initiates a drag on the source side. More...
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation. More...
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated. More...
bool | get_no_show_all () const
| Returns the current value of the GtkWidget:no-show-all property, which determines whether calls to show_all() and hide_all() will affect this widget. More...
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() and hide_all() will affect this widget. More...
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container. More...
void | unparent ()
| This function is only for use in widget implementations. More...
void | map ()
| This function is only for use in widget implementations. More...
void | unmap ()
| This function is only for use in widget implementations. More...
void | draw_insertion_cursor (Glib::RefPtr< Gdk::Drawable > drawable, const Gdk::Rectangle& area, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
void | set_tooltip_window (Window& widget)
| Replaces the default, usually yellow, window used for displaying tooltips with widget. More...
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property. More...
bool | has_no_window () const
bool | is_realized () const
bool | is_mapped () const
bool | is_toplevel () const
bool | is_drawable () const
bool | is_visible () const
bool | sensitive () const
bool | app_paintable () const
bool | receives_default () const
bool | double_buffered () const
bool | parent_sensitive () const
bool | rc_style () const
bool | is_composite_child () const
| Returns trye if the widget is a composite child of its parent. More...
WidgetFlags | get_flags () const
void | set_flags (WidgetFlags flags)
void | unset_flags (WidgetFlags flags)
Gtk::StateType | get_saved_state () const
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly. More...
Glib::RefPtr< Action > | get_action ()
| Returns the Gtk::Action that widget is a proxy for. More...
Glib::RefPtr< const Action > | get_action () const
| Returns the Gtk::Action that widget is a proxy for. More...
Requisition | get_requisition () const
| Retrieves the widget's requisition. More...
Glib::SignalProxy< void > | signal_show ()
Glib::SignalProxy< void > | signal_hide ()
Glib::SignalProxy< void > | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void > | signal_unmap ()
Glib::SignalProxy< void > | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void > | signal_unrealize ()
Glib::SignalProxy< void, Requisition*> | signal_size_request ()
Glib::SignalProxy< void, Allocation&> | signal_size_allocate ()
Glib::SignalProxy< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy< void, Widget*> | signal_parent_changed ()
| Informs objects that their parent changed. More...
Glib::SignalProxy< void, Widget*> | signal_hierarchy_changed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gtk::Style >&> | signal_style_changed ()
| The style-set signal is emitted when a new style has been set on a widget. More...
Glib::SignalProxy< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy< void, bool > | signal_grab_notify ()
Glib::SignalProxy< void, GParamSpec*> | signal_child_notify ()
| The ::child-notify signal is emitted for each child property that has changed on an object. More...
Glib::SignalProxy< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy< void > | signal_grab_focus ()
Glib::SignalProxy< bool, DirectionType > | signal_focus ()
Glib::SignalProxy< bool, GdkEvent*> | signal_event ()
Glib::SignalProxy< void, GdkEvent*> | signal_event_after ()
Glib::SignalProxy< bool, GdkEventButton*> | signal_button_press_event ()
| Event triggered by user pressing button. More...
Glib::SignalProxy< bool, GdkEventButton*> | signal_button_release_event ()
| Event triggered by user releasing button. More...
Glib::SignalProxy< bool, GdkEventScroll*> | signal_scroll_event ()
Glib::SignalProxy< bool, GdkEventMotion*> | signal_motion_notify_event ()
| Event triggered by user moving pointer. More...
Glib::SignalProxy< bool, GdkEventAny*> | signal_delete_event ()
| The delete_event signal is emitted if a user requests that a toplevel window is closed. More...
Glib::SignalProxy< bool, GdkEventExpose*> | signal_expose_event ()
| Event triggered by window requiring a refresh. More...
Glib::SignalProxy< bool, GdkEventKey*> | signal_key_press_event ()
| Event triggered by a key press will widget has focus. More...
Glib::SignalProxy< bool, GdkEventKey*> | signal_key_release_event ()
| Event triggered by a key release will widget has focus. More...
Glib::SignalProxy< bool, GdkEventCrossing*> | signal_enter_notify_event ()
| Event triggered by pointer entering widget area. More...
Glib::SignalProxy< bool, GdkEventCrossing*> | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area. More...
Glib::SignalProxy< bool, GdkEventConfigure*> | signal_configure_event ()
| Event triggered by a window resizing. More...
Glib::SignalProxy< bool, GdkEventFocus*> | signal_focus_in_event ()
Glib::SignalProxy< bool, GdkEventFocus*> | signal_focus_out_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_map_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_unmap_event ()
Glib::SignalProxy< bool, GdkEventProperty*> | signal_property_notify_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_clear_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_request_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_notify_event ()
Glib::SignalProxy< bool, GdkEventProximity*> | signal_proximity_in_event ()
Glib::SignalProxy< bool, GdkEventProximity*> | signal_proximity_out_event ()
Glib::SignalProxy< bool, GdkEventVisibility*> | signal_visibility_notify_event ()
Glib::SignalProxy< bool, GdkEventClient*> | signal_client_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_no_expose_event ()
Glib::SignalProxy< bool, GdkEventWindowState*> | signal_window_state_event ()
Glib::SignalProxy< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_begin ()
| The drag_begin signal is emitted on the drag source when a drag is started. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_end ()
| The drag_end signal is emitted on the drag source when a drag is finished. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, SelectionData&, guint, guint > | signal_drag_data_get ()
| The drag_data_get signal is emitted on the drag source when the drop site requests the data which is dragged. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_data_delete ()
| The drag_data_delete signal is emitted on the drag source when a drag with the action Gdk::ACTION_MOVE is successfully completed. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, DragResult > | signal_drag_failed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, guint > | signal_drag_leave ()
| The drag_leave signal is emitted on the drop site when the cursor leaves the widget. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
| The drag_motion signal is emitted on the drop site when the user moves the cursor over the widget during a drag. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
| The drag_drop signal is emitted on the drop site when the user drops the data onto the widget. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, int, int, const SelectionData&, guint, guint > | signal_drag_data_received ()
| The drag_data_received signal is emitted on the drop site when the dragged data has been received. More...
Glib::SignalProxy< Glib::RefPtr< Atk::Object > > | signal_get_accessible ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::Screen >&> | signal_screen_changed ()
Glib::SignalProxy< void > | signal_composited_changed ()
Glib::SignalProxy< bool > | signal_popup_menu ()
Glib::SignalProxy< bool, int, int, bool, const Glib::RefPtr< Tooltip >&> | signal_query_tooltip ()
Glib::SignalProxy< bool, GdkEventGrabBroken*> | signal_grab_broken_event ()
Glib::SignalProxy< bool, GdkEventExpose*> | signal_damage_event ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy< Container*> | property_parent ()
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Container*> | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_app_paintable () const
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_default () const
| Whether the widget can be the default widget. More...
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_composite_child () const
| Whether the widget is part of a composite widget. More...
Glib::PropertyProxy< Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy< Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy_ReadOnly< Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy< Gdk::ExtensionMode > | property_extension_events ()
| The mask that decides what kind of extension events this widget gets. More...
Glib::PropertyProxy_ReadOnly< Gdk::ExtensionMode > | property_extension_events () const
| The mask that decides what kind of extension events this widget gets. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Whether this widget has a tooltip. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Whether this widget has a tooltip. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized. More...
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether Gtk::Widget::show_all() should not affect this widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_no_show_all () const
| Whether Gtk::Widget::show_all() should not affect this widget. More...
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether or not the widget is double buffered. More...
Glib::PropertyProxy_ReadOnly< bool > | property_double_buffered () const
| Whether or not the widget is double buffered. More...
Public Member Functions inherited from Gtk::Object
virtual | ~Object ()
GtkObject* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkObject* | gobj () const
| Provides access to the underlying C GtkObject. More...
Glib::PropertyProxy< void*> | property_user_data ()
| Anonymous User Data Pointer. More...
Glib::PropertyProxy_ReadOnly< void*> | property_user_data () const
| Anonymous User Data Pointer. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Atk::Implementor
| Implementor (Implementor &&src) noexcept
Implementor & | operator= (Implementor &&src) noexcept
| ~Implementor () noexcept override
AtkImplementor * | gobj ()
const AtkImplementor * | gobj () const
Glib::RefPtr< Atk::Implementor > | wrap (AtkImplementor *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Orientable
| Orientable (Orientable&& src) noexcept
Orientable& | operator= (Orientable&& src) noexcept
| ~Orientable () noexcept override
GtkOrientable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkOrientable* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_orientation (Orientation orientation)
| Sets the orientation of the orientable. More...
Orientation | get_orientation () const
| Retrieves the orientation of the orientable. More...
Glib::PropertyProxy< Orientation > | property_orientation ()
| The orientation of the orientable. More...
Glib::PropertyProxy_ReadOnly< Orientation > | property_orientation () const
| The orientation of the orientable. More...

## Static Public Member Functions
static TargetEntry | get_drag_target_item ()
| Gets the target entry for a dragged Gtk::ToolItem. More...
static TargetEntry | get_drag_target_group ()
| Get the target entry for a dragged Gtk::ToolItemGroup. More...
Static Public Member Functions inherited from Gtk::Widget
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events. More...
static void | push_colormap (const Glib::RefPtr< const Gdk::Colormap >& cmap)
| Pushes cmap onto a global stack of colormaps; the topmost colormap on the stack will be used to create all widgets. More...
static void | pop_colormap ()
| Removes a colormap pushed with push_colormap(). More...
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call. More...
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child(). More...
static void | set_default_colormap (const Glib::RefPtr< const Gdk::Colormap >& colormap)
| Sets the default colormap to use when creating widgets. More...
static Glib::RefPtr< Style > | get_default_style ()
| Returns the default style used by all widgets initially. More...
static Glib::RefPtr< Gdk::Colormap > | get_default_colormap ()
| Obtains the default colormap used to create widgets. More...
static Glib::RefPtr< Gdk::Visual > | get_default_visual ()
| Obtains the visual of the default colormap. More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction(). More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
static Widget* | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext >& context)
Static Public Member Functions inherited from Atk::Implementor
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
Static Public Member Functions inherited from Gtk::Orientable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Gtk::ToolPalette* | wrap (GtkToolPalette* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Container
Gtk::Container* | wrap (GtkContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Object
Gtk::Object* | wrap (GtkObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Orientable
Glib::RefPtr< Gtk::Orientable > | wrap (GtkOrientable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Container
typedef sigc::slot< void, Widget& > | ForeachSlot
| For instance, void on_foreach(Gtk::Widget* widget);. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Gtk::Container
virtual void | on_add (Widget* widget)
| This is a default handler for the signal signal_add(). More...
virtual void | on_remove (Widget* widget)
| This is a default handler for the signal signal_remove(). More...
virtual void | on_check_resize ()
| This is a default handler for the signal signal_check_resize(). More...
virtual void | on_set_focus_child (Widget* widget)
| This is a default handler for the signal signal_set_focus_child(). More...
| Container ()
virtual GType | child_type_vfunc () const
virtual void | forall_vfunc (gboolean include_internals, GtkCallback callback, gpointer callback_data)
virtual char* | composite_name_vfunc (GtkWidget* child)
virtual void | set_child_property_vfunc (GtkWidget* child, guint property_id, const GValue* value, GParamSpec* pspec)
virtual void | get_child_property_vfunc (GtkWidget* child, guint property_id, GValue* value, GParamSpec* pspec) const
Glib::PropertyProxy< guint > | property_border_width ()
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy_ReadOnly< guint > | property_border_width () const
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy< ResizeMode > | property_resize_mode ()
| Specify how resize events are handled. More...
Glib::PropertyProxy_ReadOnly< ResizeMode > | property_resize_mode () const
| Specify how resize events are handled. More...
Glib::PropertyProxy_WriteOnly< Widget*> | property_child ()
| Can be used to add a new child to the container. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_size_request (Requisition* requisition)
| This is a default handler for the signal signal_size_request(). More...
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate(). More...
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed(). More...
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed(). More...
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed(). More...
virtual void | on_style_changed (const Glib::RefPtr< Gtk::Style >& previous_style)
| This is a default handler for the signal signal_style_changed(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify(). More...
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus(). More...
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus(). More...
virtual bool | on_event (GdkEvent*event)
| This is a default handler for the signal signal_event(). More...
virtual bool | on_button_press_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_press_event(). More...
virtual bool | on_button_release_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_release_event(). More...
virtual bool | on_scroll_event (GdkEventScroll*event)
| This is a default handler for the signal signal_scroll_event(). More...
virtual bool | on_motion_notify_event (GdkEventMotion*event)
| This is a default handler for the signal signal_motion_notify_event(). More...
virtual bool | on_delete_event (GdkEventAny*event)
| This is a default handler for the signal signal_delete_event(). More...
virtual bool | on_expose_event (GdkEventExpose*event)
| This is a default handler for the signal signal_expose_event(). More...
virtual bool | on_key_press_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_press_event(). More...
virtual bool | on_key_release_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_release_event(). More...
virtual bool | on_enter_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_enter_notify_event(). More...
virtual bool | on_leave_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_leave_notify_event(). More...
virtual bool | on_configure_event (GdkEventConfigure*event)
| This is a default handler for the signal signal_configure_event(). More...
virtual bool | on_focus_in_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_in_event(). More...
virtual bool | on_focus_out_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_out_event(). More...
virtual bool | on_map_event (GdkEventAny*event)
| This is a default handler for the signal signal_map_event(). More...
virtual bool | on_unmap_event (GdkEventAny*event)
| This is a default handler for the signal signal_unmap_event(). More...
virtual bool | on_property_notify_event (GdkEventProperty*event)
| This is a default handler for the signal signal_property_notify_event(). More...
virtual bool | on_selection_clear_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_clear_event(). More...
virtual bool | on_selection_request_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_request_event(). More...
virtual bool | on_selection_notify_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_notify_event(). More...
virtual bool | on_proximity_in_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_in_event(). More...
virtual bool | on_proximity_out_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_out_event(). More...
virtual bool | on_visibility_notify_event (GdkEventVisibility*event)
| This is a default handler for the signal signal_visibility_notify_event(). More...
virtual bool | on_client_event (GdkEventClient*event)
| This is a default handler for the signal signal_client_event(). More...
virtual bool | on_no_expose_event (GdkEventAny*event)
| This is a default handler for the signal signal_no_expose_event(). More...
virtual bool | on_window_state_event (GdkEventWindowState*event)
| This is a default handler for the signal signal_window_state_event(). More...
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get(). More...
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received(). More...
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin(). More...
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end(). More...
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get(). More...
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete(). More...
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave(). More...
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion(). More...
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop(). More...
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received(). More...
virtual Glib::RefPtr< Atk::Object > | on_get_accessible ()
| This is a default handler for the signal signal_get_accessible(). More...
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed(). More...
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual void | hide_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget. More...
void | unrealize ()
| This function is only useful in widget implementations. More...
void | set_mapped (bool mapped=true)
| Marks the widget as being realized. More...
void | set_realized (bool realized=true)
| Marks the widget as being realized. More...
void | style_attach ()
| This function attaches the widget's Gtk::Style to the widget's Gdk::Window. More...
void | get_child_requisition (Requisition& requisition) const
| This function is only for use in widget implementations. More...
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase& value) const
| Gets the value of a style property of widget. More...
void | realize_if_needed ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Atk::Implementor
| Implementor ()
virtual Glib::RefPtr< Object > | ref_accessibile_vfunc ()
Protected Member Functions inherited from Gtk::Orientable
| Orientable ()
| You should derive from this class to use it. More...

## Detailed Description

A ToolPalette allows you to add ToolItems to a palette-like container with various categories and drag and drop support.

ToolItems cannot be added directly to a ToolPalette - instead they are added to a ToolItemGroup which can than be added to a ToolPalette. To add a ToolItemGroup to a ToolPalette, use Gtk::Container::add().

The easiest way to use drag and drop with ToolPalette is to call add_drag_dest() with the desired drag source palette and the desired drag target widget. Then get_drag_item() can be used to get the dragged item in the "drag-data-received" signal handler of the drag target.

Since gtkmm 2.20:

## Constructor & Destructor Documentation

## ◆ ~ToolPalette()

virtual Gtk::ToolPalette::~ToolPalette | ( |  | ) |
| virtual

## ◆ ToolPalette()

Gtk::ToolPalette::ToolPalette | ( |  | ) |

## Member Function Documentation

## ◆ add_drag_dest()

void Gtk::ToolPalette::add_drag_dest | ( | Gtk::Widget& | widget,
|  | DestDefaults | flags = `DEST_DEFAULT_ALL`,
|  | ToolPaletteDragTargets | targets = `TOOL_PALETTE_DRAG_ITEMS`,
|  | Gdk::DragAction | actions = `Gdk::ACTION_COPY`
| ) |  |

Sets palette as drag source (see set_drag_source()) and sets widget as a drag destination for drags from palette.

See gtk_drag_dest_set().

Since gtkmm 2.20:

Parameters

  widget | A Gtk::Widget which should be a drag destination for palette.
  flags | The flags that specify what actions GTK+ should take for drops on that widget.
  targets | The Gtk::ToolPaletteDragTargets which the widget should support.
  actions | The Gdk::DragActions which the widget should suppport.

## ◆ get_drag_item() [1/2]

ToolItem* Gtk::ToolPalette::get_drag_item | ( | const SelectionData& | selection | ) |

Get the dragged item from the selection.

This could be a Gtk::ToolItem or a Gtk::ToolItemGroup.

Since gtkmm 2.20:

Parameters

  selection | A Gtk::SelectionData.

Returns
  The dragged item in selection.

## ◆ get_drag_item() [2/2]

const ToolItem* Gtk::ToolPalette::get_drag_item | ( | const SelectionData& | selection | ) | const

Get the dragged item from the selection.

This could be a Gtk::ToolItem or a Gtk::ToolItemGroup.

Since gtkmm 2.20:

Parameters

  selection | A Gtk::SelectionData.

Returns
  The dragged item in selection.

## ◆ get_drag_target_group()

static TargetEntry Gtk::ToolPalette::get_drag_target_group | ( |  | ) |
| static

Get the target entry for a dragged Gtk::ToolItemGroup.

Since gtkmm 2.20:

Returns
  The Gtk::TargetEntry for a dragged group.

## ◆ get_drag_target_item()

static TargetEntry Gtk::ToolPalette::get_drag_target_item | ( |  | ) |
| static

Gets the target entry for a dragged Gtk::ToolItem.

Since gtkmm 2.20:

Returns
  The Gtk::TargetEntry for a dragged item.

## ◆ get_drop_group() [1/2]

ToolItemGroup* Gtk::ToolPalette::get_drop_group | ( | int | x,
|  | int | y
| ) |  |

Gets the group at position (x, y).

Since gtkmm 2.20:

Parameters

  x | The x position.
  y | The y position.

Returns
  The Gtk::ToolItemGroup at position or `nullptr` if there is no such group.

## ◆ get_drop_group() [2/2]

const ToolItemGroup* Gtk::ToolPalette::get_drop_group | ( | int | x,
|  | int | y
| ) |  | const

Gets the group at position (x, y).

Since gtkmm 2.20:

Parameters

  x | The x position.
  y | The y position.

Returns
  The Gtk::ToolItemGroup at position or `nullptr` if there is no such group.

## ◆ get_drop_item() [1/2]

ToolItem* Gtk::ToolPalette::get_drop_item | ( | int | x,
|  | int | y
| ) |  |

Gets the item at position (x, y).

See get_drop_group().

Since gtkmm 2.20:

Parameters

  x | The x position.
  y | The y position.

Returns
  The Gtk::ToolItem at position or `nullptr` if there is no such item.

## ◆ get_drop_item() [2/2]

const ToolItem* Gtk::ToolPalette::get_drop_item | ( | int | x,
|  | int | y
| ) |  | const

Gets the item at position (x, y).

See get_drop_group().

Since gtkmm 2.20:

Parameters

  x | The x position.
  y | The y position.

Returns
  The Gtk::ToolItem at position or `nullptr` if there is no such item.

## ◆ get_exclusive()

bool Gtk::ToolPalette::get_exclusive | ( | ToolItemGroup& | group | ) | const

Gets whether group is exclusive or not.

See set_exclusive().

Since gtkmm 2.20:

Parameters

  group | A Gtk::ToolItemGroup which is a child of palette.

Returns
  `true` if group is exclusive.

## ◆ get_expand()

bool Gtk::ToolPalette::get_expand | ( | ToolItemGroup& | group | ) | const

Gets whether group should be given extra space.

See set_expand().

Since gtkmm 2.20:

Parameters

  group | A Gtk::ToolItemGroup which is a child of palette.

Returns
  `true` if group should be given extra space, `false` otherwise.

## ◆ get_group_position()

int Gtk::ToolPalette::get_group_position | ( | ToolItemGroup& | group | ) | const

Gets the position of group in palette as index.

See set_group_position().

Since gtkmm 2.20:

Parameters

  group | A Gtk::ToolItemGroup.

Returns
  The index of group or -1 if group is not a child of palette.

## ◆ get_hadjustment() [1/2]

Adjustment* Gtk::ToolPalette::get_hadjustment | ( |  | ) |

Gets the horizontal adjustment of the tool palette.

Since gtkmm 2.20:

Returns
  The horizontal adjustment of palette.

## ◆ get_hadjustment() [2/2]

const Adjustment* Gtk::ToolPalette::get_hadjustment | ( |  | ) | const

Gets the horizontal adjustment of the tool palette.

Since gtkmm 2.20:

Returns
  The horizontal adjustment of palette.

## ◆ get_icon_size()

IconSize Gtk::ToolPalette::get_icon_size | ( |  | ) | const

Gets the size of icons in the tool palette.

See set_icon_size().

Since gtkmm 2.20:

Returns
  The Gtk::IconSize of icons in the tool palette.

## ◆ get_style()

ToolbarStyle Gtk::ToolPalette::get_style | ( |  | ) | const

Gets the style (icons, text or both) of items in the tool palette.

Since gtkmm 2.20:

Returns
  The Gtk::ToolbarStyle of items in the tool palette.

## ◆ get_vadjustment() [1/2]

Adjustment* Gtk::ToolPalette::get_vadjustment | ( |  | ) |

Gets the vertical adjustment of the tool palette.

Since gtkmm 2.20:

Returns
  The vertical adjustment of palette.

## ◆ get_vadjustment() [2/2]

const Adjustment* Gtk::ToolPalette::get_vadjustment | ( |  | ) | const

Gets the vertical adjustment of the tool palette.

Since gtkmm 2.20:

Returns
  The vertical adjustment of palette.

## ◆ gobj() [1/2]

GtkToolPalette* Gtk::ToolPalette::gobj | ( |  | ) |
| inline

Provides access to the underlying C GtkObject.

## ◆ gobj() [2/2]

const GtkToolPalette* Gtk::ToolPalette::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GtkObject.

## ◆ property_icon_size() [1/2]

Glib::PropertyProxy< IconSize > Gtk::ToolPalette::property_icon_size | ( |  | ) |

Size of icons in this tool palette.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_icon_size() [2/2]

Glib::PropertyProxy_ReadOnly< IconSize > Gtk::ToolPalette::property_icon_size | ( |  | ) | const

Size of icons in this tool palette.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_icon_size_set() [1/2]

Glib::PropertyProxy< bool > Gtk::ToolPalette::property_icon_size_set | ( |  | ) |

Whether the icon-size property has been set.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_icon_size_set() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ToolPalette::property_icon_size_set | ( |  | ) | const

Whether the icon-size property has been set.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_toolbar_style() [1/2]

Glib::PropertyProxy< ToolbarStyle > Gtk::ToolPalette::property_toolbar_style | ( |  | ) |

Style of items in the tool palette.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_toolbar_style() [2/2]

Glib::PropertyProxy_ReadOnly< ToolbarStyle > Gtk::ToolPalette::property_toolbar_style | ( |  | ) | const

Style of items in the tool palette.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_drag_source()

void Gtk::ToolPalette::set_drag_source | ( | ToolPaletteDragTargets | targets = `TOOL_PALETTE_DRAG_ITEMS` | ) |

Sets the tool palette as a drag source.

Enables all groups and items in the tool palette as drag sources on button 1 and button 3 press with copy and move actions. See gtk_drag_source_set().

Since gtkmm 2.20:

Parameters

  targets | The Gtk::ToolPaletteDragTargets which the widget should support.

## ◆ set_exclusive()

void Gtk::ToolPalette::set_exclusive | ( | ToolItemGroup& | group,
|  | bool | exclusive
| ) |  |

Sets whether the group should be exclusive or not.

If an exclusive group is expanded all other groups are collapsed.

Since gtkmm 2.20:

Parameters

  group | A Gtk::ToolItemGroup which is a child of palette.
  exclusive | Whether the group should be exclusive or not.

## ◆ set_expand()

void Gtk::ToolPalette::set_expand | ( | ToolItemGroup& | group,
|  | bool | expand = `true`
| ) |  |

Sets whether the group should be given extra space.

Since gtkmm 2.20:

Parameters

  group | A Gtk::ToolItemGroup which is a child of palette.
  expand | Whether the group should be given extra space.

## ◆ set_group_position()

void Gtk::ToolPalette::set_group_position | ( | ToolItemGroup& | group,
|  | int | position
| ) |  |

Sets the position of the group as an index of the tool palette.

If position is 0 the group will become the first child, if position is -1 it will become the last child.

Since gtkmm 2.20:

Parameters

  group | A Gtk::ToolItemGroup which is a child of palette.
  position | A new index for group.

## ◆ set_icon_size()

void Gtk::ToolPalette::set_icon_size | ( | IconSize | icon_size | ) |

Sets the size of icons in the tool palette.

Since gtkmm 2.20:

Parameters

  icon_size | The Gtk::IconSize that icons in the tool palette shall have.

## ◆ set_style()

void Gtk::ToolPalette::set_style | ( | ToolbarStyle | style | ) |

Sets the style (text, icons or both) of items in the tool palette.

Since gtkmm 2.20:

Parameters

  style | The Gtk::ToolbarStyle that items in the tool palette shall have.

## ◆ unset_icon_size()

void Gtk::ToolPalette::unset_icon_size | ( |  | ) |

Unsets the tool palette icon size set with set_icon_size(), so that user preferences will be used to determine the icon size.

Since gtkmm 2.20:

## ◆ unset_style()

void Gtk::ToolPalette::unset_style | ( |  | ) |

Unsets a toolbar style set with set_style(), so that user preferences will be used to determine the toolbar style.

Since gtkmm 2.20:

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::ToolPalette* wrap | ( | GtkToolPalette * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/toolpalette.h